#! /usr/bin/python

#    Copyright (c) 2011 David Calle <davidc@framli.eu>

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import locale, urllib, urllib2, simplejson, gobject, socket
from zeitgeist import client, datamodel

# Timeout in seconds
socket.setdefaulttimeout(5)

# Determine session's locale to optimize queries
locale.setlocale(locale.LC_MESSAGES, '')
session_locale = locale.getlocale(locale.LC_MESSAGES)[0].split("_")[0]

# Define Google specific parameters
g_langRestrict = '&langRestrict=' + session_locale
g_printType = '&printType=books'
g_apiKey = '&key=AIzaSyCWEg-NFIxCkMpKKDTd4biRUJ7Th8Py2L8'
g_baseQuery = 'https://www.googleapis.com/books/v1/volumes?alt=json' + g_apiKey + g_printType

# Define Blekko specific parameters
b_apiKey = '?auth=70fc3602'
b_baseQuery = 'https://blekko.com/ws/' + b_apiKey + '&q='

# Define Wikipedia specific parameters



#
# Blekko API 
#
def blekko_search(q):
    try:
        q = q.replace(" ", "+")
        url = (b_baseQuery + '%s' % (q))
        results = simplejson.loads(urllib2.urlopen(url).read())
        print "blekko_search"
        return results['RESULT']
    except KeyError:
        return
    except (IOError, urllib2.URLError, urllib2.HTTPError, simplejson.JSONDecodeError):
        print "blekko_search_is_error"
        return

#
# Wikipedia API 
#
def wikipedia_search(q):
    try:
        q = q.replace(" ", "|")
        print q
        url = ("http://" + session_locale +'.wikipedia.org/w/api.php?action=opensearch&limit=12&format=json&search=%s' % (q))
        results = simplejson.loads(urllib2.urlopen(url).read())
        print "wikipedia_search"
        return results[1]
    except KeyError:
        return
    except (IOError, urllib2.URLError, urllib2.HTTPError, simplejson.JSONDecodeError):
        print "wikipedia_search_is_error"
        return

#
# Google Books API 
# <http://code.google.com/apis/books/docs/js/jsondevguide.html>
#
def google_books_search(q, filterIs, more, ln):
    try:
        q = q.replace(" ", "+")
        if more != '':
            q = q.encode('ascii', 'xmlcharrefreplace')
        query = urllib.urlencode({'q': q })
        if query != '' or query != 'q=' or query != 'q':
            if filterIs != '':
                filterIs = '&filter=' + filterIs
            if ln != '':
                ln = g_langRestrict
            url = (g_baseQuery+ filterIs + ln +'&%s' % (query))
            results = simplejson.loads(urllib2.urlopen(url).read())
            if results['totalItems'] != 0:
                return results
            else:
                return
        else:
            return
    except (IOError, urllib2.URLError, urllib2.HTTPError, simplejson.JSONDecodeError):
        print "google_books_search_is_error"
        return

#
# Google Images search
# <http://code.google.com/apis/imagesearch/v1/jsondevguide.html>
#
def google_image_search(q):
    try:
        q = q.replace(" ", "+")
        query = urllib.urlencode({'q': q.encode('utf-8') })
        if query != '' or query != 'q=' or query != 'q':
            url = ('https://ajax.googleapis.com/ajax/services/search/images?v=1.0&imgtype=face&rsz=1&safe=active&%s'
              % (query))
            f = urllib2.urlopen(url)
            content = f.read()
            results = simplejson.loads(content)
            print "google_image_search " + str(results['responseStatus'])
            if results['responseStatus'] == 200:
                return results['responseData']['results']
        else:
            return
    except (IOError, urllib2.URLError, urllib2.HTTPError, simplejson.JSONDecodeError):
        print "google_image_search_is_error"
        return
